/* 

                          Firewall Builder

                 Copyright (C) 2000 Vadim Kurland

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: Rule.hh,v 1.3 2001/12/19 12:47:02 lord Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef __RULE_HH_FLAG__
#define __RULE_HH_FLAG__

#include <fwbuilder/Group.hh>

namespace libfwbuilder
{

class FWOptions;

class Rule : public Group 
{
    public:

    Rule();

    DECLARE_FWOBJECT_SUBTYPE(Rule);

    void createAndAddRuleElement(const char* element_name);

    void setPosition(int n);
    int  getPosition();

    void disable();
    void enable();
    bool isDisabled();

    virtual FWOptions* getOptionsObject();
};

class PolicyRule : public Rule 
{
    public:
    PolicyRule();
    virtual void fromXML(xmlNodePtr parent);
    virtual xmlNodePtr toXML      (xmlNodePtr parent);
    DECLARE_FWOBJECT_SUBTYPE(PolicyRule);
    virtual FWOptions* getOptionsObject();
};

class NATRule : public Rule 
{
    public:
    NATRule() : Rule() {}
    virtual void fromXML(xmlNodePtr parent);
    virtual xmlNodePtr toXML      (xmlNodePtr parent);
    DECLARE_FWOBJECT_SUBTYPE(NATRule);
    virtual FWOptions* getOptionsObject();
};

}

#endif //__RULE_HH_FLAG__
